<!DOCTYPE html>
<html lang="en-US">
  <head>
    <meta charset="utf-8">
    <title>A better data pretty-printer - Pitches - Swift Forums</title>
    <meta name="description" content="With this post, I hope to open a discussion of the design requirements for a library, similar to Python&amp;#39;s pprint, that could eventually be incorporated into the standard library and inform the design of many parts of the&amp;hellip;">
    <meta name="generator" content="Discourse 2.5.0.beta2 - https://github.com/discourse/discourse version 5b2b769eb7ed54d2c4d094f1a970067c5db776b6">
<link rel="icon" type="image/png" href="https://aws1.discourse-cdn.com/swift/optimized/2X/6/610ef4c64700c53fad713dda8c9563c461d82e41_2_32x32.ico">
<link rel="apple-touch-icon" type="image/png" href="https://aws1.discourse-cdn.com/swift/optimized/1X/0a90dde98a223f5841eeca49d89dc9f57592e8d6_2_180x180.png">
<meta name="theme-color" content="#ffffff">
<meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, user-scalable=yes, viewport-fit=cover">
<link rel="canonical" href="https://forums.swift.org/t/a-better-data-pretty-printer/34914" />
<script type="application/ld+json">{"@context":"http://schema.org","@type":"WebSite","url":"https://forums.swift.org","potentialAction":{"@type":"SearchAction","target":"https://forums.swift.org/search?q={search_term_string}","query-input":"required name=search_term_string"}}</script>
<link rel="search" type="application/opensearchdescription+xml" href="https://forums.swift.org/opensearch.xml" title="Swift Forums Search">

      <link href="https://sjc5.discourse-cdn.com/swift/stylesheets/desktop_4f402d09e484c857d1671f284defe31161ba9c95.css?__ws=forums.swift.org" media="all" rel="stylesheet" data-target="desktop" data-theme-id="2"/>
      <link href="https://sjc5.discourse-cdn.com/swift/stylesheets/desktop_theme_2_dc6232b5ac28a29abf58a95aa95d5d1a0a14eb05.css?__ws=forums.swift.org" media="all" rel="stylesheet" data-target="desktop_theme" data-theme-id="2"/>
    <meta name="apple-mobile-web-app-capable" content="yes">
    
        <link rel="alternate" type="application/rss+xml" title="RSS feed of &#39;A better data pretty-printer&#39;" href="https://forums.swift.org/t/a-better-data-pretty-printer/34914.rss" />
    <meta property="og:site_name" content="Swift Forums" />
<meta name="twitter:card" content="summary" />
<meta name="twitter:image" content="https://aws1.discourse-cdn.com/swift/original/1X/0a90dde98a223f5841eeca49d89dc9f57592e8d6.png" />
<meta property="og:image" content="https://aws1.discourse-cdn.com/swift/original/1X/0a90dde98a223f5841eeca49d89dc9f57592e8d6.png" />
<meta property="og:url" content="https://forums.swift.org/t/a-better-data-pretty-printer/34914" />
<meta name="twitter:url" content="https://forums.swift.org/t/a-better-data-pretty-printer/34914" />
<meta property="og:title" content="A better data pretty-printer" />
<meta name="twitter:title" content="A better data pretty-printer" />
<meta property="og:description" content="With this post, I hope to open a discussion of the design requirements for a library, similar to Python&#39;s pprint, that could eventually be incorporated into the standard library and inform the design of many parts of the Swift ecosystem.  Introduction There are many contexts—from educational/research tools like Playgrounds and Colab Notebooks to industrial programming activities like debugging and logging, in which it&#39;s important to be able to easily visualize/understand Swift data structures.  ..." />
<meta name="twitter:description" content="With this post, I hope to open a discussion of the design requirements for a library, similar to Python&#39;s pprint, that could eventually be incorporated into the standard library and inform the design of many parts of the Swift ecosystem.  Introduction There are many contexts—from educational/research tools like Playgrounds and Colab Notebooks to industrial programming activities like debugging and logging, in which it&#39;s important to be able to easily visualize/understand Swift data structures.  ..." />
<meta name="twitter:label1" value="Reading time" />
<meta name="twitter:data1" value="7 mins 🕑" />
<meta name="twitter:label2" value="Likes" />
<meta name="twitter:data2" value="53 ❤" />
<meta property="article:published_time" content="2020-03-29T22:27:37+00:00" />
<meta property="og:ignore_canonical" content="true" />



    
  </head>
  <body class="crawler">
    
    <header>
      <a href="/">
          <img src="https://aws1.discourse-cdn.com/swift/original/2X/0/0d7ab3b633e07bf8ec99bdc18e22ad89d8934801.png" alt="Swift Forums" id="site-logo" style="max-width: 150px;">
      </a>
    </header>
    <div id="main-outlet" class="wrap">
        <h1 class="crawler-topic-title">
    <a href="/t/a-better-data-pretty-printer/34914">A better data pretty-printer</a>
  </h1>

  <div id="breadcrumbs" itemscope itemtype="http://schema.org/BreadcrumbList">
      <div itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
        <a href="https://forums.swift.org/c/evolution" class="badge-wrapper bullet" itemprop="item">
          <span class="badge-category-bg"></span>
          <span class="category-title" itemprop="name">Evolution</span>
        </a>
        <meta itemprop="position" content="1" />
      </div>
      <div itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
        <a href="https://forums.swift.org/c/evolution/pitches" class="badge-wrapper bullet" itemprop="item">
          <span class="badge-category-bg"></span>
          <span class="category-title" itemprop="name">Pitches</span>
        </a>
        <meta itemprop="position" content="2" />
      </div>
  </div>


  


    <div itemscope itemtype='http://schema.org/DiscussionForumPosting' class='topic-body crawler-post'>
        <div class='crawler-post-meta'>
          <span class="creator" itemprop="author" itemscope itemtype="http://schema.org/Person">
            <a itemprop="url" href='https://forums.swift.org/u/dabrahams'><span itemprop='name'>dabrahams</span></a>
            (Dave Abrahams)
          </span>

          <span class="crawler-post-infos">
              <meta itemprop='datePublished' content='2020-03-29T22:27:37Z'>
              <time itemprop='dateModified' datetime='2020-03-30T04:29:49Z' class='post-time'>
                March 30, 2020,  4:29am
              </time>
          <span itemprop='position'>#1</span>
          </span>
        </div>
        <div class='post' itemprop='articleBody'>
          <p>With this post, I hope to open a discussion of the design requirements for a library, similar to Python's <a href="https://docs.python.org/3.4/library/pprint.html" rel="nofollow noopener">pprint</a>, that could eventually be incorporated into the standard library and inform the design of many parts of the Swift ecosystem.</p>
<h1>Introduction</h1>
<p>There are many contexts—from educational/research tools like Playgrounds and <a href="https://colab.research.google.com/notebook#create=true&amp;language=swift" rel="nofollow noopener">Colab Notebooks</a> to industrial programming activities like debugging and logging, in which it's important to be able to easily visualize/understand Swift data structures.  For consumption by actual humans, though, Swift's facilities for formatting data leave a <em>lot</em> to be desired.  Take a trivial example:</p>
<pre><code class="lang-swift">(0..&lt;10).map { Array($0..&lt;10) + (0..&lt;$0) }
</code></pre>
<p>If you <code>print</code> this expression, you'll see:</p>
<pre><code class="lang-swift">[[0, 1, 2, 3, 4, 5, 6, 7, 8, 9], [1, 2, 3, 4, 5, 6, 7, 8, 9, 0], [2, 3, 4, 5, 6, 7, 8, 9, 0, 1], [3, 4, 5, 6, 7, 8, 9, 0, 1, 2], [4, 5, 6, 7, 8, 9, 0, 1, 2, 3], [5, 6, 7, 8, 9, 0, 1, 2, 3, 4], [6, 7, 8, 9, 0, 1, 2, 3, 4, 5], [7, 8, 9, 0, 1, 2, 3, 4, 5, 6], [8, 9, 0, 1, 2, 3, 4, 5, 6, 7], [9, 0, 1, 2, 3, 4, 5, 6, 7, 8]]
</code></pre>
<p>Now, if you <em>happen</em> to be in a context like a terminal where you get line-wrapping, this <em>might</em> be enough to give you a sense of what's going on.  If the data were any longer, though, it would be a disaster.</p>
<p>Evaluate the expression in the REPL, and you get 122 lines of even less useful output:</p>
<pre><code class="lang-swift">$R0: [[Int]] = 10 values {
  [0] = 10 values {
    [0] = 0
    [1] = 1
    [2] = 2
    [3] = 3
    [4] = 4
    [5] = 5
    [6] = 6
    [7] = 7
    [8] = 8
    [9] = 9
  }
  [1] = 10 values {
    [0] = 1
    [1] = 2
    [2] = 3
    ...
</code></pre>
<p>The representations we get from LLDB, in the GUI and in the output of <code>p</code> or <code>po</code>, are similarly frustrating (the GUI is actually the worst for visualization: it makes me click 11 triangles to reveal the data).  I usually end up typing <code>p print(x)</code> in the debugger to get something I can actually digest.  Playgrounds?  Don't get me started <img src="https://sjc5.discourse-cdn.com/swift/images/emoji/apple/wink.png?v=9" title=":wink:" class="emoji" alt=":wink:">; the workaround is similar but far more necessary.</p>
<p>For contrast, now fire up <a href="https://en.wikipedia.org/wiki/IPython" rel="nofollow noopener">ipython</a> from the command line and evaluate the corresponding expression:</p>
<pre><code class="lang-python">In [3]: [list(range(x, 10)) + list(range(0, x)) for x in range(0, 10)]
Out[3]:
[[0, 1, 2, 3, 4, 5, 6, 7, 8, 9],
 [1, 2, 3, 4, 5, 6, 7, 8, 9, 0],
 [2, 3, 4, 5, 6, 7, 8, 9, 0, 1],
 [3, 4, 5, 6, 7, 8, 9, 0, 1, 2],
 [4, 5, 6, 7, 8, 9, 0, 1, 2, 3],
 [5, 6, 7, 8, 9, 0, 1, 2, 3, 4],
 [6, 7, 8, 9, 0, 1, 2, 3, 4, 5],
 [7, 8, 9, 0, 1, 2, 3, 4, 5, 6],
 [8, 9, 0, 1, 2, 3, 4, 5, 6, 7],
 [9, 0, 1, 2, 3, 4, 5, 6, 7, 8]]
</code></pre>
<p>Brilliant!  Not only can I take the whole data structure in at a glance, but I can see the relationships between adjacent rows.</p>
<p>Naturally, not every data structure is this simple to format usefully, but surely we can aspire to do much better than we do today.</p>
<h2>The Pitch</h2>
<p>To be clear, I'm not proposing to change anything in the tools, language, or standard library in the near term; there's far too much to be explored and proven out in a separate package first.  I propose to design  a library that serves the same purpose as <a href="https://docs.python.org/3.4/library/pprint.html" rel="nofollow noopener">pprint</a>, which is what ipython uses to generate the result above. I believe, if we get it right, similar principles could <em>eventually</em> be applied to improve standard library print, debuggers, playgrounds, and the REPL (of course, if Apple wants to run with some of these ideas and begin improving tools earlier, I'm sure nobody will complain <img src="https://sjc5.discourse-cdn.com/swift/images/emoji/apple/wink.png?v=9" title=":wink:" class="emoji" alt=":wink:">).</p>
<p>As far as I know, there's no existing Swift library that serves the purpose.  The point of this thread is to discuss the design of such a library, which features are essential, and what problems need to be solved. I'll kick it off with a few things to think about:</p>
<ul>
<li>References: Ideally one never formats an instance twice.  When an instance is referenced from multiple points in a data structure, how is it presented?</li>
<li>Abbreviation:  in my use cases, data can be extremely large, and it's sometimes going important to see the “shape” of the data without <em>all</em> of the detail.
<ul>
<li>How can we effectively abbreviate an array?
<ul>
<li>I might want to see the first few elements and then an ellipsis.</li>
<li>I'd still want to know the length; how do I print that?</li>
</ul>
</li>
<li>I <em>think</em> this approach generalizes to most types</li>
<li>Are there data structures that need different treatment?</li>
</ul>
</li>
<li>Columns: is it important to see data structures on separate lines organized into columns?</li>
</ul>
<p>Thanks for your attention,<br>
Dave</p>
        </div>

        <meta itemprop='headline' content='A better data pretty-printer'>

        <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
           <meta itemprop="interactionType" content="http://schema.org/LikeAction"/>
           <meta itemprop="userInteractionCount" content="33" />
           <span class='post-likes'>33 Likes</span>
         </div>

         <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
            <meta itemprop="interactionType" content="http://schema.org/CommentAction"/>
            <meta itemprop="userInteractionCount" content="3" />
          </div>

            <div class='crawler-linkback-list' itemscope itemtype='http://schema.org/ItemList'>
            </div>

    </div>
    <div itemscope itemtype='http://schema.org/DiscussionForumPosting' class='topic-body crawler-post'>
        <div class='crawler-post-meta'>
          <span class="creator" itemprop="author" itemscope itemtype="http://schema.org/Person">
            <a itemprop="url" href='https://forums.swift.org/u/wtedst'><span itemprop='name'>wtedst</span></a>
            (Nikita Belov)
          </span>

          <span class="crawler-post-infos">
              <meta itemprop='datePublished' content='2020-03-29T22:40:30Z'>
              <time itemprop='dateModified' datetime='2020-03-29T22:40:48Z' class='post-time'>
                March 29, 2020, 10:40pm
              </time>
          <span itemprop='position'>#2</span>
          </span>
        </div>
        <div class='post' itemprop='articleBody'>
          <p>I'm not familiar with pprint, so sorry if there is some misunderstanding, but a couple of already existing features come to mind, namely <code>Custom(Debug)StringConvertible</code> and <code>Mirror</code>. Don't they already solve the issue to some satisfactory extent?</p>
        </div>

        <meta itemprop='headline' content='A better data pretty-printer'>

        <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
           <meta itemprop="interactionType" content="http://schema.org/LikeAction"/>
           <meta itemprop="userInteractionCount" content="0" />
           <span class='post-likes'></span>
         </div>

         <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
            <meta itemprop="interactionType" content="http://schema.org/CommentAction"/>
            <meta itemprop="userInteractionCount" content="1" />
          </div>


    </div>
    <div itemscope itemtype='http://schema.org/DiscussionForumPosting' class='topic-body crawler-post'>
        <div class='crawler-post-meta'>
          <span class="creator" itemprop="author" itemscope itemtype="http://schema.org/Person">
            <a itemprop="url" href='https://forums.swift.org/u/scanon'><span itemprop='name'>scanon</span></a>
            (Steve Canon)
          </span>

          <span class="crawler-post-infos">
              <meta itemprop='datePublished' content='2020-03-29T22:42:13Z'>
              <time itemprop='dateModified' datetime='2020-03-29T22:43:23Z' class='post-time'>
                March 29, 2020, 10:43pm
              </time>
          <span itemprop='position'>#3</span>
          </span>
        </div>
        <div class='post' itemprop='articleBody'>
          <p>S4TF has already tackled this to some extent in the specific context of ShapedArray's <code>description( ... summarizing: true)</code>, which produces output very similar to python's pretty printer. <a class="mention" href="/u/rxwei">@rxwei</a> can probably offer some of his experience implementing that.</p>
        </div>

        <meta itemprop='headline' content='A better data pretty-printer'>

        <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
           <meta itemprop="interactionType" content="http://schema.org/LikeAction"/>
           <meta itemprop="userInteractionCount" content="3" />
           <span class='post-likes'>3 Likes</span>
         </div>

         <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
            <meta itemprop="interactionType" content="http://schema.org/CommentAction"/>
            <meta itemprop="userInteractionCount" content="2" />
          </div>


    </div>
    <div itemscope itemtype='http://schema.org/DiscussionForumPosting' class='topic-body crawler-post'>
        <div class='crawler-post-meta'>
          <span class="creator" itemprop="author" itemscope itemtype="http://schema.org/Person">
            <a itemprop="url" href='https://forums.swift.org/u/dabrahams'><span itemprop='name'>dabrahams</span></a>
            (Dave Abrahams)
          </span>

          <span class="crawler-post-infos">
              <time itemprop='datePublished' datetime='2020-03-29T22:46:42Z' class='post-time'>
                March 29, 2020, 10:46pm
              </time>
          <span itemprop='position'>#4</span>
          </span>
        </div>
        <div class='post' itemprop='articleBody'>
          <p>Those are the facilities used by today's tools for rendering data as text, but the resulting rendering is often suboptimal.  That's the problem I want to solve.</p>
<p>Solving it would probably involve using those same facilities; the more so the better.  But if you're satisfied with the renderings you get today… I guess I'll register that as one vote for “it ain't broke.”</p>
<p>Thanks for your reply,<br>
Dave</p>
        </div>

        <meta itemprop='headline' content='A better data pretty-printer'>

        <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
           <meta itemprop="interactionType" content="http://schema.org/LikeAction"/>
           <meta itemprop="userInteractionCount" content="1" />
           <span class='post-likes'>1 Like</span>
         </div>

         <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
            <meta itemprop="interactionType" content="http://schema.org/CommentAction"/>
            <meta itemprop="userInteractionCount" content="0" />
          </div>


    </div>
    <div itemscope itemtype='http://schema.org/DiscussionForumPosting' class='topic-body crawler-post'>
        <div class='crawler-post-meta'>
          <span class="creator" itemprop="author" itemscope itemtype="http://schema.org/Person">
            <a itemprop="url" href='https://forums.swift.org/u/dabrahams'><span itemprop='name'>dabrahams</span></a>
            (Dave Abrahams)
          </span>

          <span class="crawler-post-infos">
              <time itemprop='datePublished' datetime='2020-03-29T22:48:52Z' class='post-time'>
                March 29, 2020, 10:48pm
              </time>
          <span itemprop='position'>#5</span>
          </span>
        </div>
        <div class='post' itemprop='articleBody'>
          <aside class="quote no-group" data-username="scanon" data-post="3" data-topic="34914" data-full="true">
<div class="title">
<div class="quote-controls"></div>
<img alt width="20" height="20" src="https://sjc5.discourse-cdn.com/swift/user_avatar/forums.swift.org/scanon/40/2445_2.png" class="avatar"> scanon:</div>
<blockquote>
<p>S4TF has already tackled this to some extent in the specific context of ShapedArray's <code>description( ... summarizing: true)</code> , which produces output very similar to python's pretty printer. <a class="mention" href="/u/rxwei">@rxwei</a> can probably offer some of his experience implementing that.</p>
</blockquote>
</aside>
<p>Thanks, <a class="mention" href="/u/scanon">@scanon</a>; I'd be really interested in what <a class="mention" href="/u/rxwei">@rxwei</a> has to say.  Wouldn't it be funny to find part of the answer so close to home!?</p>
        </div>

        <meta itemprop='headline' content='A better data pretty-printer'>

        <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
           <meta itemprop="interactionType" content="http://schema.org/LikeAction"/>
           <meta itemprop="userInteractionCount" content="0" />
           <span class='post-likes'></span>
         </div>

         <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
            <meta itemprop="interactionType" content="http://schema.org/CommentAction"/>
            <meta itemprop="userInteractionCount" content="0" />
          </div>


    </div>
    <div itemscope itemtype='http://schema.org/DiscussionForumPosting' class='topic-body crawler-post'>
        <div class='crawler-post-meta'>
          <span class="creator" itemprop="author" itemscope itemtype="http://schema.org/Person">
            <a itemprop="url" href='https://forums.swift.org/u/owenv'><span itemprop='name'>owenv</span></a>
            (Owen Voorhees)
          </span>

          <span class="crawler-post-infos">
              <meta itemprop='datePublished' content='2020-03-29T23:45:00Z'>
              <time itemprop='dateModified' datetime='2020-03-29T23:45:20Z' class='post-time'>
                March 29, 2020, 11:45pm
              </time>
          <span itemprop='position'>#6</span>
          </span>
        </div>
        <div class='post' itemprop='articleBody'>
          <p>In case anyone's interested, the S4TF method is <a href="https://github.com/tensorflow/swift-apis/blob/aad3149d56350736fca45f4c84614eb6c1ac4cdf/Sources/TensorFlow/Core/ShapedArray.swift#L334">here</a>.</p>
<p>Based on the above, I see two potential areas of improvement here:</p>
<ol>
<li>
<p>Better context sensitivity for CustomDebugStringConvertible implementations. For example, allowing customization based on terminal/line width, compact/expanded forms, fitting descriptions into columns.</p>
</li>
<li>
<p>A replacement for <code>String(reflecting:)</code> with <code>pprint</code>-like behavior. This could leverage the new customization points above so that for the most part only primitive types need to worry about layout and sizing details. Unusual data structures that wanted fully custom representations could continue to provide them through protocol conformances.</p>
</li>
</ol>
<p>Both kinds of improvements seem like they could be prototyped in a package fairly easily by building on top of the existing standard library facilities. Overall, I think this is definitely an area worth exploring, thanks for kicking off the discussion!</p>
        </div>

        <meta itemprop='headline' content='A better data pretty-printer'>

        <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
           <meta itemprop="interactionType" content="http://schema.org/LikeAction"/>
           <meta itemprop="userInteractionCount" content="1" />
           <span class='post-likes'>1 Like</span>
         </div>

         <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
            <meta itemprop="interactionType" content="http://schema.org/CommentAction"/>
            <meta itemprop="userInteractionCount" content="0" />
          </div>

            <div class='crawler-linkback-list' itemscope itemtype='http://schema.org/ItemList'>
            </div>

    </div>
    <div itemscope itemtype='http://schema.org/DiscussionForumPosting' class='topic-body crawler-post'>
        <div class='crawler-post-meta'>
          <span class="creator" itemprop="author" itemscope itemtype="http://schema.org/Person">
            <a itemprop="url" href='https://forums.swift.org/u/dan-zheng'><span itemprop='name'>dan-zheng</span></a>
            (Dan Zheng)
          </span>

          <span class="crawler-post-infos">
              <meta itemprop='datePublished' content='2020-03-29T23:50:55Z'>
              <time itemprop='dateModified' datetime='2020-03-30T00:14:36Z' class='post-time'>
                March 30, 2020, 12:14am
              </time>
          <span itemprop='position'>#7</span>
          </span>
        </div>
        <div class='post' itemprop='articleBody'>
          <aside class="quote no-group" data-username="scanon" data-post="3" data-topic="34914">
<div class="title">
<div class="quote-controls"></div>
<img alt width="20" height="20" src="https://sjc5.discourse-cdn.com/swift/user_avatar/forums.swift.org/scanon/40/2445_2.png" class="avatar"> scanon:</div>
<blockquote>
<p>S4TF has already tackled this to some extent in the specific context of ShapedArray's <code>description( ... summarizing: true)</code> , which produces output very similar to python's pretty printer.</p>
</blockquote>
</aside>
<p><a href="https://bugs.swift.org/browse/TF-419">TF-419</a> has a short survey of n-d array printing approaches: NumPy, PyTorch, and TensorFlow.</p>
<p><code>ShapedArray</code> pretty printing was done in <a href="https://github.com/apple/swift/pull/23837">https://github.com/apple/swift/pull/23837</a>, adapting PyTorch's approach, which in turn was simplified from NumPy.</p>
<p>There are a few formatting options:</p>
<ul>
<li>
<code>lineWidth</code>: max line width for printing.
<ul>
<li>
<code>linewidth</code> from <a href="https://github.com/numpy/numpy/blob/078ac01a85c4db46e7f148829c2e0d0e0f30c36f/numpy/core/arrayprint.py#L114-L116">NumPy</a>/<a href="https://github.com/pytorch/pytorch/blob/e397f87c4bd490148e3db9ee680b5320bcdec6c6/torch/_tensor_str.py#L35-L37">PyTorch</a>.</li>
</ul>
</li>
<li>
<code>edgeElementCount</code>: max number of elements to print before and after summarization via <code>...</code>.
<ul>
<li>
<code>edgeitems</code> from <a href="https://github.com/numpy/numpy/blob/078ac01a85c4db46e7f148829c2e0d0e0f30c36f/numpy/core/arrayprint.py#L111-L113">NumPy</a>/<a href="https://github.com/pytorch/pytorch/blob/e397f87c4bd490148e3db9ee680b5320bcdec6c6/torch/_tensor_str.py#L33-L34">PyTorch</a>.</li>
</ul>
</li>
<li>
<code>summarizing</code>: if true, summarize description when element count exceeds twice <code>edgeElementCount</code>.
<ul>
<li>Adapted from <code>threshold</code> from <a href="https://github.com/numpy/numpy/blob/078ac01a85c4db46e7f148829c2e0d0e0f30c36f/numpy/core/arrayprint.py#L107-L110">NumPy</a>/<a href="https://github.com/pytorch/pytorch/blob/e397f87c4bd490148e3db9ee680b5320bcdec6c6/torch/_tensor_str.py#L31-L32">PyTorch</a>, but is more direct.</li>
</ul>
</li>
</ul>
<hr>
<p><a href="https://github.com/dan-zheng/swift/blob/878031f6d648053c6da52b9808ca3cbd4c34afed/test/TensorFlowRuntime/string_description.swift">Here are some <code>ShapedArray</code>/<code>Tensor</code> pretty printing examples.</a> They basically match NumPy.<br>
Here's the example from the OP:</p>
<pre><code class="lang-swift">import TensorFlow // https://github.com/tensorflow/swift-apis
let scalars = Array(0..&lt;10).flatMap { Array($0..&lt;10) + (0..&lt;$0) }
let array = ShapedArray&lt;Int&gt;(shape: [10, 10], scalars: scalars)
print(array)
// [[0, 1, 2, 3, 4, 5, 6, 7, 8, 9],
//  [1, 2, 3, 4, 5, 6, 7, 8, 9, 0],
//  [2, 3, 4, 5, 6, 7, 8, 9, 0, 1],
//  [3, 4, 5, 6, 7, 8, 9, 0, 1, 2],
//  [4, 5, 6, 7, 8, 9, 0, 1, 2, 3],
//  [5, 6, 7, 8, 9, 0, 1, 2, 3, 4],
//  [6, 7, 8, 9, 0, 1, 2, 3, 4, 5],
//  [7, 8, 9, 0, 1, 2, 3, 4, 5, 6],
//  [8, 9, 0, 1, 2, 3, 4, 5, 6, 7],
//  [9, 0, 1, 2, 3, 4, 5, 6, 7, 8]]
</code></pre>
<p>The approach scales okay for scalar types with single-line descriptions (example below), but poorly for scalar types with multi-line descriptions:</p>
<pre><code class="lang-swift">import TensorFlow
struct Foo {
  var x, y: Float
}
func randomFloat() -&gt; Float {
  Float.random(in: 0..&lt;10)
}
let scalars = Array(0..&lt;30).map { _ in Foo(x: randomFloat(), y: randomFloat()) }
let array = ShapedArray(shape: [3, 10], scalars: scalars)
print(array)
// [[  Foo(x: 0.4480654, y: 8.283595),  Foo(x: 9.3662815, y: 6.9708605),
//     Foo(x: 9.307922, y: 3.0516386),    Foo(x: 8.633892, y: 8.495968),
//     Foo(x: 8.039076, y: 6.2687416),   Foo(x: 9.036159, y: 5.5231953),
//     Foo(x: 9.479092, y: 5.6267643),  Foo(x: 0.27412534, y: 5.213334),
//     Foo(x: 9.509889, y: 5.4769177),  Foo(x: 5.3902664, y: 7.6097817)],
//  [   Foo(x: 8.531519, y: 9.247487),  Foo(x: 4.4876156, y: 4.8444886),
//      Foo(x: 8.801109, y: 9.923952),    Foo(x: 1.137932, y: 8.767807),
//        Foo(x: 9.818808, y: 7.9524),  Foo(x: 0.8811009, y: 3.1550765),
//     Foo(x: 3.2264006, y: 9.470762),   Foo(x: 0.83419025, y: 8.05618),
//    Foo(x: 5.1218147, y: 4.5521345),   Foo(x: 6.997285, y: 0.6220269)],
//  [  Foo(x: 8.387425, y: 1.3053352),  Foo(x: 1.4895821, y: 7.3696184),
//      Foo(x: 2.824216, y: 0.857808),    Foo(x: 1.861074, y: 9.140683),
//   Foo(x: 0.027683973, y: 8.813936),   Foo(x: 5.523879, y: 5.2888365),
//      Foo(x: 1.207906, y: 8.352948), Foo(x: 0.018079877, y: 6.803925),
//     Foo(x: 2.4139428, y: 9.780199),   Foo(x: 1.4824015, y: 8.396431)]]
</code></pre>
        </div>

        <meta itemprop='headline' content='A better data pretty-printer'>

        <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
           <meta itemprop="interactionType" content="http://schema.org/LikeAction"/>
           <meta itemprop="userInteractionCount" content="5" />
           <span class='post-likes'>5 Likes</span>
         </div>

         <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
            <meta itemprop="interactionType" content="http://schema.org/CommentAction"/>
            <meta itemprop="userInteractionCount" content="0" />
          </div>

            <div class='crawler-linkback-list' itemscope itemtype='http://schema.org/ItemList'>
            </div>

    </div>
    <div itemscope itemtype='http://schema.org/DiscussionForumPosting' class='topic-body crawler-post'>
        <div class='crawler-post-meta'>
          <span class="creator" itemprop="author" itemscope itemtype="http://schema.org/Person">
            <a itemprop="url" href='https://forums.swift.org/u/jrose'><span itemprop='name'>jrose</span></a>
            (Jordan Rose)
          </span>

          <span class="crawler-post-infos">
              <time itemprop='datePublished' datetime='2020-03-30T00:09:53Z' class='post-time'>
                March 30, 2020, 12:09am
              </time>
          <span itemprop='position'>#8</span>
          </span>
        </div>
        <div class='post' itemprop='articleBody'>
          <p>I wonder how far you could get with special-casing Mirror.DisplayStyle's <code>collection</code> and <code>dictionary</code> cases. You could use that to build up the shape of the data structure and then render the elements individually.</p>
        </div>

        <meta itemprop='headline' content='A better data pretty-printer'>

        <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
           <meta itemprop="interactionType" content="http://schema.org/LikeAction"/>
           <meta itemprop="userInteractionCount" content="2" />
           <span class='post-likes'>2 Likes</span>
         </div>

         <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
            <meta itemprop="interactionType" content="http://schema.org/CommentAction"/>
            <meta itemprop="userInteractionCount" content="1" />
          </div>


    </div>
    <div itemscope itemtype='http://schema.org/DiscussionForumPosting' class='topic-body crawler-post'>
        <div class='crawler-post-meta'>
          <span class="creator" itemprop="author" itemscope itemtype="http://schema.org/Person">
            <a itemprop="url" href='https://forums.swift.org/u/dabrahams'><span itemprop='name'>dabrahams</span></a>
            (Dave Abrahams)
          </span>

          <span class="crawler-post-infos">
              <time itemprop='datePublished' datetime='2020-03-30T02:18:54Z' class='post-time'>
                March 30, 2020,  2:18am
              </time>
          <span itemprop='position'>#9</span>
          </span>
        </div>
        <div class='post' itemprop='articleBody'>
          <p>Sure; I think there are lots of things we could do with what’s there, including detecting and using <code>Custom[Debug]StringConvertible</code> conformances when their results are short enough.  But I really hope this thread can be about domain requirements and API for users before we get too far into implementation.</p>
        </div>

        <meta itemprop='headline' content='A better data pretty-printer'>

        <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
           <meta itemprop="interactionType" content="http://schema.org/LikeAction"/>
           <meta itemprop="userInteractionCount" content="1" />
           <span class='post-likes'>1 Like</span>
         </div>

         <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
            <meta itemprop="interactionType" content="http://schema.org/CommentAction"/>
            <meta itemprop="userInteractionCount" content="2" />
          </div>


    </div>
    <div itemscope itemtype='http://schema.org/DiscussionForumPosting' class='topic-body crawler-post'>
        <div class='crawler-post-meta'>
          <span class="creator" itemprop="author" itemscope itemtype="http://schema.org/Person">
            <a itemprop="url" href='https://forums.swift.org/u/Jon_Shier'><span itemprop='name'>Jon_Shier</span></a>
            (Jon Shier)
          </span>

          <span class="crawler-post-infos">
              <time itemprop='datePublished' datetime='2020-03-30T03:52:16Z' class='post-time'>
                March 30, 2020,  3:52am
              </time>
          <span itemprop='position'>#10</span>
          </span>
        </div>
        <div class='post' itemprop='articleBody'>
          <aside class="quote no-group" data-username="dabrahams" data-post="9" data-topic="34914">
<div class="title">
<div class="quote-controls"></div>
<img alt width="20" height="20" src="https://sjc5.discourse-cdn.com/swift/user_avatar/forums.swift.org/dabrahams/40/9815_2.png" class="avatar"> dabrahams:</div>
<blockquote>
<p>But I really hope this thread can be about domain requirements and API for users before we get too far into implementation.</p>
</blockquote>
</aside>
<p>What kind of domain and other API were you thinking? Personally, I think some of this could be handled at the <code>String</code> level with better or more formatting built in. For example, I often find myself wanting to print levels of indented text, such as when printing Alamofire <code>Request</code> descriptions. I would love to be able define indentation levels or columns for output without having to manually calculate them. In Alamofire right now, we print a response's HTTP headers something like this:</p>
<pre><code class="lang-swift">[Headers]:
Access-Control-Allow-Origin: *
Content-Length: 464
Content-Type: application/json
Date: Mon, 30 Mar 2020 03:46:07 GMT
Server: gunicorn/19.9.0
access-control-allow-credentials: true
</code></pre>
<p>I would really like it to look something like this:</p>
<pre><code class="lang-swift">[Headers]:
    Access-Control-Allow-Origin: *
    Content-Length: 464
    Content-Type: application/json
    Date: Mon, 30 Mar 2020 03:46:07 GMT
    Server: gunicorn/19.9.0
    access-control-allow-credentials: true
</code></pre>
<p>This is currently accomplished through simple <code>String</code> interpolation:</p>
<pre><code class="lang-swift">"""
[Headers]:
\(sortedHeaders)
"""
</code></pre>
<p>So something simple to control indentation would be very nice.</p>
<pre><code class="lang-swift">"""
[Headers]:
\(sortedHeaders, indentLevel: 1)
"""
</code></pre>
<p>Even better if you could customize the indent representation or perhaps have relative indentation.</p>
        </div>

        <meta itemprop='headline' content='A better data pretty-printer'>

        <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
           <meta itemprop="interactionType" content="http://schema.org/LikeAction"/>
           <meta itemprop="userInteractionCount" content="0" />
           <span class='post-likes'></span>
         </div>

         <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
            <meta itemprop="interactionType" content="http://schema.org/CommentAction"/>
            <meta itemprop="userInteractionCount" content="0" />
          </div>


    </div>
    <div itemscope itemtype='http://schema.org/DiscussionForumPosting' class='topic-body crawler-post'>
        <div class='crawler-post-meta'>
          <span class="creator" itemprop="author" itemscope itemtype="http://schema.org/Person">
            <a itemprop="url" href='https://forums.swift.org/u/benrimmington'><span itemprop='name'>benrimmington</span></a>
            (Ben Rimmington)
          </span>

          <span class="crawler-post-infos">
              <time itemprop='datePublished' datetime='2020-03-30T05:19:35Z' class='post-time'>
                March 30, 2020,  5:19am
              </time>
          <span itemprop='position'>#11</span>
          </span>
        </div>
        <div class='post' itemprop='articleBody'>
          <aside class="quote no-group" data-username="dabrahams" data-post="1" data-topic="34914">
<div class="title">
<div class="quote-controls"></div>
<img alt width="20" height="20" src="https://sjc5.discourse-cdn.com/swift/user_avatar/forums.swift.org/dabrahams/40/9815_2.png" class="avatar"> dabrahams:</div>
<blockquote>
<p>(the GUI is actually the worst for visualization: it makes me click 11 triangles to reveal the data)</p>
</blockquote>
</aside>
<p>You can <em>option-click</em> a disclosure triangle in any <a href="https://developer.apple.com/design/human-interface-guidelines/macos/windows-and-views/outline-views/">outline view</a> to expand (or collapse) all of the item's children.</p>
<p>A <a href="https://github.blog/changelog/2018-08-17-collapse-all-diffs-in-a-pull-request-at-once/">similar feature</a> is available in the <em>Files changed</em> tab on GitHub.</p>
        </div>

        <meta itemprop='headline' content='A better data pretty-printer'>

        <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
           <meta itemprop="interactionType" content="http://schema.org/LikeAction"/>
           <meta itemprop="userInteractionCount" content="0" />
           <span class='post-likes'></span>
         </div>

         <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
            <meta itemprop="interactionType" content="http://schema.org/CommentAction"/>
            <meta itemprop="userInteractionCount" content="1" />
          </div>

            <div class='crawler-linkback-list' itemscope itemtype='http://schema.org/ItemList'>
            </div>

    </div>
    <div itemscope itemtype='http://schema.org/DiscussionForumPosting' class='topic-body crawler-post'>
        <div class='crawler-post-meta'>
          <span class="creator" itemprop="author" itemscope itemtype="http://schema.org/Person">
            <a itemprop="url" href='https://forums.swift.org/u/ktoso'><span itemprop='name'>ktoso</span></a>
            (Konrad `ktoso` Malawski)
          </span>

          <span class="crawler-post-infos">
              <time itemprop='datePublished' datetime='2020-03-30T05:35:57Z' class='post-time'>
                March 30, 2020,  5:35am
              </time>
          <span itemprop='position'>#12</span>
          </span>
        </div>
        <div class='post' itemprop='articleBody'>
          <aside class="quote no-group" data-username="dabrahams" data-post="9" data-topic="34914">
<div class="title">
<div class="quote-controls"></div>
<img alt width="20" height="20" src="https://sjc5.discourse-cdn.com/swift/user_avatar/forums.swift.org/dabrahams/40/9815_2.png" class="avatar"> dabrahams:</div>
<blockquote>
<p>But I really hope this thread can be about domain requirements and API for users before we get too far into implementation.</p>
</blockquote>
</aside>
<p>Personally I'd love for an improved print experience. I work around this constantly though it's less painful since I use (keyboard / IDE) macros (real ones would be nice <img src="https://sjc5.discourse-cdn.com/swift/images/emoji/apple/wink.png?v=9" title=":wink:" class="emoji" alt=":wink:">) to type out tons of boilerplate to get the printout I want (or have to type those for loops every single time manually while debugging).</p>
<p>For more inspiration you may also want to skim Scala's version of this: <a href="http://www.lihaoyi.com/PPrint/" rel="nofollow noopener">http://www.lihaoyi.com/PPrint/</a><br>
it handles not only collections but also case classes (think "structs") quite well.</p>
<p>Another issue to keep in mind while looking into a prettier print to <em>please</em> have it behave consistently invoking either <code>description</code> and <code>debugDescription</code> all the way through, and not like e.g. collections handle this in swift today, which is super surprising (description of a collection invokes debugDescription of elements): <a href="https://bugs.swift.org/browse/SR-11001" rel="nofollow noopener">https://bugs.swift.org/browse/SR-11001</a> (perhaps worth revisiting that SR as well concurrently...?)</p>
        </div>

        <meta itemprop='headline' content='A better data pretty-printer'>

        <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
           <meta itemprop="interactionType" content="http://schema.org/LikeAction"/>
           <meta itemprop="userInteractionCount" content="1" />
           <span class='post-likes'>1 Like</span>
         </div>

         <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
            <meta itemprop="interactionType" content="http://schema.org/CommentAction"/>
            <meta itemprop="userInteractionCount" content="2" />
          </div>

            <div class='crawler-linkback-list' itemscope itemtype='http://schema.org/ItemList'>
            </div>

    </div>
    <div itemscope itemtype='http://schema.org/DiscussionForumPosting' class='topic-body crawler-post'>
        <div class='crawler-post-meta'>
          <span class="creator" itemprop="author" itemscope itemtype="http://schema.org/Person">
            <a itemprop="url" href='https://forums.swift.org/u/dabrahams'><span itemprop='name'>dabrahams</span></a>
            (Dave Abrahams)
          </span>

          <span class="crawler-post-infos">
              <meta itemprop='datePublished' content='2020-03-30T14:06:55Z'>
              <time itemprop='dateModified' datetime='2020-03-30T16:50:46Z' class='post-time'>
                March 30, 2020,  4:50pm
              </time>
          <span itemprop='position'>#13</span>
          </span>
        </div>
        <div class='post' itemprop='articleBody'>
          <aside class="quote no-group" data-username="ktoso" data-post="12" data-topic="34914">
<div class="title">
<div class="quote-controls"></div>
<img alt width="20" height="20" src="https://sjc5.discourse-cdn.com/swift/user_avatar/forums.swift.org/ktoso/40/3443_2.png" class="avatar"> ktoso:</div>
<blockquote>
<p>For more inspiration you may also want to skim Scala's version of this: <a href="http://www.lihaoyi.com/PPrint/" rel="nofollow noopener">http://www.lihaoyi.com/PPrint/ </a><br>
it handles not only collections but also case classes (think "structs") quite well.</p>
</blockquote>
</aside>
<p>Thanks, that sounds really interesting.</p>
<aside class="quote no-group" data-username="ktoso" data-post="12" data-topic="34914">
<div class="title">
<div class="quote-controls"></div>
<img alt width="20" height="20" src="https://sjc5.discourse-cdn.com/swift/user_avatar/forums.swift.org/ktoso/40/3443_2.png" class="avatar"> ktoso:</div>
<blockquote>
<p>Another issue to keep in mind while looking into a prettier print to <em>please</em> have it behave consistently invoking either <code>description</code> and <code>debugDescription</code> all the way through, and not like e.g. collections handle this in swift today, which is super surprising (description of a collection invokes debugDescription of elements): <a href="https://bugs.swift.org/browse/SR-11001" rel="nofollow noopener">https://bugs.swift.org/browse/SR-11001 </a> (perhaps worth revisiting that SR as well concurrently...?)</p>
</blockquote>
</aside>
<p>IMO, most people would find the results even more surprising if we did that.  Please see <a href="https://bugs.swift.org/browse/SR-11001?focusedCommentId=55378&amp;page=com.atlassian.jira.plugin.system.issuetabpanels:comment-tabpanel#comment-55378" rel="nofollow noopener">my reply</a> in the issue.</p>
        </div>

        <meta itemprop='headline' content='A better data pretty-printer'>

        <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
           <meta itemprop="interactionType" content="http://schema.org/LikeAction"/>
           <meta itemprop="userInteractionCount" content="2" />
           <span class='post-likes'>2 Likes</span>
         </div>

         <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
            <meta itemprop="interactionType" content="http://schema.org/CommentAction"/>
            <meta itemprop="userInteractionCount" content="1" />
          </div>

            <div class='crawler-linkback-list' itemscope itemtype='http://schema.org/ItemList'>
            </div>

    </div>
    <div itemscope itemtype='http://schema.org/DiscussionForumPosting' class='topic-body crawler-post'>
        <div class='crawler-post-meta'>
          <span class="creator" itemprop="author" itemscope itemtype="http://schema.org/Person">
            <a itemprop="url" href='https://forums.swift.org/u/dabrahams'><span itemprop='name'>dabrahams</span></a>
            (Dave Abrahams)
          </span>

          <span class="crawler-post-infos">
              <time itemprop='datePublished' datetime='2020-03-30T16:49:15Z' class='post-time'>
                March 30, 2020,  4:49pm
              </time>
          <span itemprop='position'>#14</span>
          </span>
        </div>
        <div class='post' itemprop='articleBody'>
          <aside class="quote no-group quote-modified" data-username="dabrahams" data-post="1" data-topic="34914">
<div class="title">
<div class="quote-controls"></div>
<img alt width="20" height="20" src="https://sjc5.discourse-cdn.com/swift/user_avatar/forums.swift.org/dabrahams/40/9815_2.png" class="avatar"> dabrahams:</div>
<blockquote>
<aside class="quote no-group" data-username="dabrahams" data-post="1" data-topic="34914">
<div class="title">
<div class="quote-controls"></div>
<img alt width="20" height="20" src="https://sjc5.discourse-cdn.com/swift/user_avatar/forums.swift.org/dabrahams/40/9815_2.png" class="avatar"> dabrahams:</div>
<blockquote>
<p>(the GUI is actually the worst for visualization: it makes me click 11 triangles to reveal the data)</p>
</blockquote>
</aside>
<p>You can <em>option-click</em> a disclosure triangle in any <a href="https://developer.apple.com/design/human-interface-guidelines/macos/windows-and-views/outline-views/" rel="nofollow noopener">outline view </a> to expand (or collapse) all of the item's children.</p>
<p>A <a href="https://github.blog/changelog/2018-08-17-collapse-all-diffs-in-a-pull-request-at-once/" rel="nofollow noopener">similar feature </a> is available in the <em>Files changed</em> tab on GitHub.</p>
</blockquote>
</aside>
<p>That's still one keystroke and a click too many for my purposes, and then the result is still similar to what I get from <code>p</code> or <code>po</code>, with poor use of screen real-estate and lots of information I don't normally need.  Note that GitHub <em>starts</em> by showing you the useful information.  But I don't really want to spend too much time discussing the tools here; my point in bringing them is was merely to point out that they might eventually benefit from work done on this library.</p>
        </div>

        <meta itemprop='headline' content='A better data pretty-printer'>

        <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
           <meta itemprop="interactionType" content="http://schema.org/LikeAction"/>
           <meta itemprop="userInteractionCount" content="2" />
           <span class='post-likes'>2 Likes</span>
         </div>

         <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
            <meta itemprop="interactionType" content="http://schema.org/CommentAction"/>
            <meta itemprop="userInteractionCount" content="0" />
          </div>


    </div>
    <div itemscope itemtype='http://schema.org/DiscussionForumPosting' class='topic-body crawler-post'>
        <div class='crawler-post-meta'>
          <span class="creator" itemprop="author" itemscope itemtype="http://schema.org/Person">
            <a itemprop="url" href='https://forums.swift.org/u/ktoso'><span itemprop='name'>ktoso</span></a>
            (Konrad `ktoso` Malawski)
          </span>

          <span class="crawler-post-infos">
              <time itemprop='datePublished' datetime='2020-03-30T17:09:12Z' class='post-time'>
                March 30, 2020,  5:09pm
              </time>
          <span itemprop='position'>#15</span>
          </span>
        </div>
        <div class='post' itemprop='articleBody'>
          <aside class="quote no-group" data-username="dabrahams" data-post="13" data-topic="34914">
<div class="title">
<div class="quote-controls"></div>
<img alt width="20" height="20" src="https://sjc5.discourse-cdn.com/swift/user_avatar/forums.swift.org/dabrahams/40/9815_2.png" class="avatar"> dabrahams:</div>
<blockquote>
<p>Thanks, that sounds really interesting.</p>
</blockquote>
</aside>
<p>You're welcome <img src="https://sjc5.discourse-cdn.com/swift/images/emoji/apple/slight_smile.png?v=9" title=":slight_smile:" class="emoji" alt=":slight_smile:"> I think the width / height concepts are pretty good there, they translate to when an output gets \n-ed or truncated etc.</p>
<aside class="quote no-group quote-modified" data-username="dabrahams" data-post="13" data-topic="34914">
<div class="title">
<div class="quote-controls"></div>
<img alt width="20" height="20" src="https://sjc5.discourse-cdn.com/swift/user_avatar/forums.swift.org/dabrahams/40/9815_2.png" class="avatar"> dabrahams:</div>
<blockquote>
<aside class="quote no-group" data-username="ktoso" data-post="12" data-topic="34914">
<div class="title">
<div class="quote-controls"></div>
<img alt width="20" height="20" src="https://sjc5.discourse-cdn.com/swift/user_avatar/forums.swift.org/ktoso/40/3443_2.png" class="avatar"> ktoso:</div>
<blockquote>
<p>Another issue to keep in mind while looking into a prettier print to <em>please</em> have it behave consistently invoking either <code>description</code> and <code>debugDescription</code> all the way through, and not like e.g. collections handle this in swift today, which is super surprising (description of a collection invokes debugDescription of elements): <a href="https://bugs.swift.org/browse/SR-11001" rel="nofollow noopener">https://bugs.swift.org/browse/SR-11001 </a> (perhaps worth revisiting that SR as well concurrently...?)</p>
</blockquote>
</aside>
<p>IMO, most people would find the results even more surprising if we did that. Please see <a href="https://bugs.swift.org/browse/SR-11001?focusedCommentId=55378&amp;page=com.atlassian.jira.plugin.system.issuetabpanels:comment-tabpanel#comment-55378" rel="nofollow noopener">my reply </a> in the issue.</p>
</blockquote>
</aside>
<p>Thanks for the reply there -- that puts much into context. I'm convienced that changing those semantics is not a good idea. Though, Nate sums the conflicting use cases up very well there – what <code>debugDescription</code> is is more about where it's printed, and not with what intent. So we can't change names and semantics etc, but...</p>
<p>So pprint will have to follow the same semantics, using debugDescription of elements if inside a collection etc. That's good and I understand why we want this (though would love more docs on the protocol why/when it gets invoked).</p>
<p>At the same time, while introducing a <code>pprint</code> could it also serve the "interactively (println/log) debugging" use-cases (3 &amp; 4). It seems to me it might easily address those if it had a way to use a Mirror to obtain all the values to print -- then <code>description</code> and <code>debugDescription</code> both contain things which normal users may want to see, and some <code>pprint(mirroring_pickBetterName: value)</code> would do what I was after all along -- print "all" the values pretty formatted (multiline etc), as I've now realized that using debugDescription for manually doing the pretty multi-line print leads to unexpected outputs (because collections).</p>
<p>Do you think this is something we could consider having as part such API?</p>
        </div>

        <meta itemprop='headline' content='A better data pretty-printer'>

        <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
           <meta itemprop="interactionType" content="http://schema.org/LikeAction"/>
           <meta itemprop="userInteractionCount" content="0" />
           <span class='post-likes'></span>
         </div>

         <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
            <meta itemprop="interactionType" content="http://schema.org/CommentAction"/>
            <meta itemprop="userInteractionCount" content="1" />
          </div>


    </div>
    <div itemscope itemtype='http://schema.org/DiscussionForumPosting' class='topic-body crawler-post'>
        <div class='crawler-post-meta'>
          <span class="creator" itemprop="author" itemscope itemtype="http://schema.org/Person">
            <a itemprop="url" href='https://forums.swift.org/u/dabrahams'><span itemprop='name'>dabrahams</span></a>
            (Dave Abrahams)
          </span>

          <span class="crawler-post-infos">
              <time itemprop='datePublished' datetime='2020-03-30T18:25:31Z' class='post-time'>
                March 30, 2020,  6:25pm
              </time>
          <span itemprop='position'>#16</span>
          </span>
        </div>
        <div class='post' itemprop='articleBody'>
          <aside class="quote no-group" data-username="ktoso" data-post="15" data-topic="34914">
<div class="title">
<div class="quote-controls"></div>
<img alt width="20" height="20" src="https://sjc5.discourse-cdn.com/swift/user_avatar/forums.swift.org/ktoso/40/3443_2.png" class="avatar"> ktoso:</div>
<blockquote>
<p>At the same time, while introducing a <code>pprint</code> could it also serve the "interactively (println/log) debugging" use-cases (3 &amp; 4). It seems to me it might easily address those if it had a way to use a Mirror to obtain all the values to print -- then <code>description</code> and <code>debugDescription</code> both contain things which normal users may want to see, and some <code>pprint(mirroring_pickBetterName: value)</code> would do what I was after all along -- print "all" the values pretty formatted (multiline etc), as I've now realized that using debugDescription for manually doing the pretty multi-line print leads to unexpected outputs (because collections).</p>
<p>Do you think this is something we could consider having as part such API?</p>
</blockquote>
</aside>
<p>I don't think I understand what you're proposing.  As I've said elsewhere in this thread, I take “use a <code>Mirror</code>” for granted as one of the bases for the implementation of this library. I don't think I know what you were after all along.</p>
<p>That said, it might be a good idea for the library to have a lower-level API that uses a visitor for formatting individual pieces pf the output, so you can customize how any given type is formatted without having to write all the wrapping and indenting bits.</p>
        </div>

        <meta itemprop='headline' content='A better data pretty-printer'>

        <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
           <meta itemprop="interactionType" content="http://schema.org/LikeAction"/>
           <meta itemprop="userInteractionCount" content="1" />
           <span class='post-likes'>1 Like</span>
         </div>

         <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
            <meta itemprop="interactionType" content="http://schema.org/CommentAction"/>
            <meta itemprop="userInteractionCount" content="1" />
          </div>


    </div>
    <div itemscope itemtype='http://schema.org/DiscussionForumPosting' class='topic-body crawler-post'>
        <div class='crawler-post-meta'>
          <span class="creator" itemprop="author" itemscope itemtype="http://schema.org/Person">
            <a itemprop="url" href='https://forums.swift.org/u/ktoso'><span itemprop='name'>ktoso</span></a>
            (Konrad `ktoso` Malawski)
          </span>

          <span class="crawler-post-infos">
              <meta itemprop='datePublished' content='2020-03-31T02:45:40Z'>
              <time itemprop='dateModified' datetime='2020-03-31T02:45:55Z' class='post-time'>
                March 31, 2020,  2:45am
              </time>
          <span itemprop='position'>#17</span>
          </span>
        </div>
        <div class='post' itemprop='articleBody'>
          <p>Looking back at it I guess it being implemented in terms of mirrors is kind of obvious in retrospect, though was not really spelled out. I think this has quite the potential to solve what "debug" printing in my opinion should have been (while the <code>debugDescription</code> IMHO remains somewhat weirdly named to what it's actually used for -- when embedded in collections).</p>
<p>Overall, looking forward to this - could help avoid ad-hoc implementing pretty formatted outputs way too many times for some types I own <img src="https://sjc5.discourse-cdn.com/swift/images/emoji/apple/slight_smile.png?v=9" title=":slight_smile:" class="emoji" alt=":slight_smile:"></p>
        </div>

        <meta itemprop='headline' content='A better data pretty-printer'>

        <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
           <meta itemprop="interactionType" content="http://schema.org/LikeAction"/>
           <meta itemprop="userInteractionCount" content="0" />
           <span class='post-likes'></span>
         </div>

         <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
            <meta itemprop="interactionType" content="http://schema.org/CommentAction"/>
            <meta itemprop="userInteractionCount" content="0" />
          </div>


    </div>
    <div itemscope itemtype='http://schema.org/DiscussionForumPosting' class='topic-body crawler-post'>
        <div class='crawler-post-meta'>
          <span class="creator" itemprop="author" itemscope itemtype="http://schema.org/Person">
            <a itemprop="url" href='https://forums.swift.org/u/Karl'><span itemprop='name'>Karl</span></a>
            (👑🦆)
          </span>

          <span class="crawler-post-infos">
              <meta itemprop='datePublished' content='2020-03-31T15:52:43Z'>
              <time itemprop='dateModified' datetime='2020-03-31T16:17:23Z' class='post-time'>
                March 31, 2020,  4:17pm
              </time>
          <span itemprop='position'>#18</span>
          </span>
        </div>
        <div class='post' itemprop='articleBody'>
          <p>This is a really interesting topic and I'm glad we're looking in to it!</p>
<p>Data visualisation is important for far more than just ML; getting a better idea of what your data looks like can be critical to identifying optimisation opportunities or gaps in test coverage.</p>
<aside class="quote no-group" data-username="dabrahams" data-post="1" data-topic="34914">
<div class="title">
<div class="quote-controls"></div>
<img alt width="20" height="20" src="https://sjc5.discourse-cdn.com/swift/user_avatar/forums.swift.org/dabrahams/40/9815_2.png" class="avatar"> dabrahams:</div>
<blockquote>
<p>There are many contexts—from educational/research tools like Playgrounds and <a href="https://colab.research.google.com/notebook#create=true&amp;language=swift">Colab Notebooks </a> to industrial programming activities like debugging and logging, in which it's important to be able to easily visualize/understand Swift data structures. For consumption by actual humans, though, Swift's facilities for formatting data leave a <em>lot</em> to be desired.</p>
</blockquote>
</aside>
<p>A question: are we talking about visualising/understanding <em>data</em> using Swift, or visualising/understanding the data structures themselves? I'm going to assume you mean the former.</p>
<p>When it comes to multi-dimensional data, like the examples in the OP, it's clear that we can do better -- at least up to 2 dimensions. If we want to get really ambitious and look beyond that, it's possible that a visualiser with more advanced graphics capabilities (like an Xcode Playground or embedded web-content in a notebook) could render visualisations of even higher-dimensional data. Is the idea that this would be limited to the terminal, or are we looking at adding support for richer visualisers as well?</p>
<p>Even if limited to the terminal and 1 or 2 dimensions, we could do better. I'd really like some way to add value colourisation, and basic statistics like min/max/mean/stddev, for instance.</p>
<p>EDIT: Here's an example of the kind of things you can do with Python's <a href="https://github.com/willmcgugan/rich">rich library</a>:</p>
<p>                    <a href="https://raw.githubusercontent.com/willmcgugan/rich/master/imgs/print.png" target="_blank" class="onebox" rel="nofollow ugc noopener">
            <img src="https://aws1.discourse-cdn.com/swift/original/2X/6/605cca20ead59c0944bf010e1bfb7cdb78f1ae6d.png" width="690" height="470">
          </a>

<br>
                    <a href="https://raw.githubusercontent.com/willmcgugan/rich/master/imgs/table.png" target="_blank" class="onebox" rel="nofollow ugc noopener">
            <img src="https://aws1.discourse-cdn.com/swift/original/2X/5/5f9d04f7c347c27cad55bf80806a3af60ea35bc6.png" width="690" height="420">
          </a>

</p>
        </div>

        <meta itemprop='headline' content='A better data pretty-printer'>

        <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
           <meta itemprop="interactionType" content="http://schema.org/LikeAction"/>
           <meta itemprop="userInteractionCount" content="1" />
           <span class='post-likes'>1 Like</span>
         </div>

         <div itemprop="interactionStatistic" itemscope itemtype="http://schema.org/InteractionCounter">
            <meta itemprop="interactionType" content="http://schema.org/CommentAction"/>
            <meta itemprop="userInteractionCount" content="0" />
          </div>

            <div class='crawler-linkback-list' itemscope itemtype='http://schema.org/ItemList'>
            </div>

    </div>






    </div>
    <footer class="container wrap">
      <nav class='crawler-nav' itemscope itemtype='http://schema.org/SiteNavigationElement'>
        <ul>
        <li itemprop="name"><a href='/' itemprop="url">Home </a></li>
        <li itemprop="name"><a href='/categories' itemprop="url">Categories </a></li>
        <li itemprop="name"><a href='/guidelines' itemprop="url">FAQ/Guidelines </a></li>
        <li itemprop="name"><a href='/tos' itemprop="url">Terms of Service </a></li>
        <li itemprop="name"><a href='/privacy' itemprop="url">Privacy Policy </a></li>
        </ul>
      </nav>
      <p class='powered-by-link'>Powered by <a href="https://www.discourse.org">Discourse</a>, best viewed with JavaScript enabled</p>
    </footer>
    <center>
<a href="https://forums.swift.org/tos">Terms of Service</a><p></p>
<a href="https://www.apple.com/legal/privacy/en-ww/">Privacy Policy</a><p></p>
<a href="https://www.apple.com/legal/privacy/en-ww/cookies/">Cookie Policy</a>
</center>

    
  </body>
  
</html>
